#!/usr/bin/perl
#
#           RiSearch
#
# web search engine, version 0.99
# (c) Sergej Tarasov, 2000
#
# Homepage: http://risearch.webservis.ru/
# email: risearch@webservis.ru



# File extensions to index
$file_ext = '\.(html|txt|htm|shtml)$';

# List of directories, which should not be indexed
$no_index_dir = '(img|image|temp|tmp|cgi-bin)$';

# Directory where yours html files are located
# Type "." for the current directory
$base_dir = ".";

# Base URL of your site
$base_url = "http://www.server.com/";

# Full word indexing ("YES" or "NO")
$FULL_WORD = "NO";

# Change below only if you need multilanguage support
# With default settings script will work with
# english and russian (win1251 encoding) languages

# Capital letters
$CAP_LETTERS = '\xC0-\xDF';

# Lower case letters
$LOW_LETTERS = '\xE0-\xFF';

# Change this as above
sub to_lower_case {
   my $str = shift;
   $str =~ tr{\xC0-\xDF}{\xE0-\xFF};
   return $str;
}

#--- end of configuration --- don't change anything below ---

#DEFINE CONSTANTS
$HASHSIZE = 90001;
$cfn = 0;
$kbcount = 0;


open FINFO, ">finfo" or die "Could not open finfo.";
open SITEWORDS, ">sitewords" or die "Could not open sitewords.";
open WORD_IND, ">word_ind" or die "Could not open word_ind.";
binmode(WORD_IND);

@time=localtime(time);
$time="$time[2]:$time[1]:$time[0]";
print "Scan started: $time\n";


&scan_files($base_dir);

@time=localtime(time);
$time="$time[2]:$time[1]:$time[0]";
print "Scan finished: $time\n";
print "Creating databases. Please wait, this can take several minuts.\n";

close(FINFO);

    foreach $word (sort keys %words) {
    	$wordpos{$word} .= pack("NN", tell(SITEWORDS), tell(WORD_IND) );
    	print SITEWORDS "$word\n";
    	print WORD_IND pack("N", length($words{$word}));
    	print WORD_IND $words{$word};
    };

close(SITEWORDS);
close(WORD_IND);

    &build_hash;


sub  scan_files {

     my $dir=$_[0];
     my (@dirs,@files,$filename,$newdir,$list,$url);

     opendir(DIR,$dir) or (warn "Cannot open $dir: $!" and next);
     @dirs=grep {!(/^\./) && -d "$dir/$_"} readdir(DIR);
     rewinddir(DIR);
     @files=grep {!(/^\./) && /$file_ext/i && -f "$dir/$_"} readdir(DIR);
     closedir (DIR);

     for $list(0..$#dirs) {
     	 if ($dirs[$list] =~ /$no_index_dir/i) {next};
         $newdir=$dir."/".$dirs[$list];
         &scan_files ($newdir);
     }
     for $list(0..$#files) {
         $filename=$dir."/".$files[$list];
         ($url = $filename) =~ s/^$base_dir\///;
         $url = $base_url.$url;
         &index_file($filename,$url);
         $cfn++;
     }
     return 1;
}


sub index_file {
    my $filename=$_[0];
    my $url=$_[1];
    local $/;
    open FILE, $filename;
    @dum = stat(FILE);
    $size = int($dum[7] / 1024);
    $kbcount += $size;
    print "$cfn -> $filename; totalsize -> $kbcount\n";
    $html_text = <FILE>;
    ($title) = ($html_text =~ m#<TITLE>\s*(.*?)\s*</TITLE>#is);
    if ($title eq "") {$title = "No title"};
    $html_text =~ s/<script.*?<\/script>/ /igs;
    $html_text =~ s/<style.*?<\/style>/ /igs;
#    ($plain_text = $html_text) =~ s/<(?:[^>'"]*|(['"]).*?\1)*>//gs;
    ($plain_text = $html_text) =~ s/<[^>]*>//gs;
    $plain_text =~ s/\s+/ /gs;
    $descript = substr($plain_text,0,256);
    $plain_text =~ s/[^a-zA-Z$CAP_LETTERS$LOW_LETTERS]/ /gs;
    $plain_text =~ s/ {2,}/ /gs;
    $plain_text =~ tr/A-Z/a-z/;
    $plain_text = to_lower_case($plain_text);
    $fileinfo = $url."::".$size."::".$title."::".$descript;
    $pos = tell(FINFO);
    print FINFO "$fileinfo\n";
    
    @results=split (/ /,$plain_text);
    %seen = ();
    @uniq = ();
    foreach $item (@results) {
        unless ($seen{$item}) {
            $seen{$item} = 1;
            push(@uniq, $item);
        };
    };
    foreach (@uniq){
       chomp($_);
       if (length($_) >= 3) { $words{$_}.= pack("N", $pos) }
    }
};     # sub index_file



sub build_hash {
    
    for ($i=0; $i<$HASHSIZE; $i++) {$hash_array[$i] = ""};
    foreach $word (keys %words) {
        @letters = unpack("C*", $word);
        if ($FULL_WORD eq "YES") { $subbound = scalar(@letters)-3 }
        else { $subbound = 1 }
        if (scalar(@letters)==3) {$subbound = 1}
        
        for ($i=0; $i<$subbound; $i++){
    	    $a = $letters[$i];
       	    $b = $letters[$i+1];
    	    $c = $letters[$i+2];
    	    $d = $letters[$i+3];
    	    $num = int( ($a*14511 - $b*13779 + $c*$d*94333)/5 ) % $HASHSIZE;
    	    $hash_array[$num] .= ($word."::");
    	};   # for $i
    };   # foreach $word
    
    open HASH, ">hash" or die "Could not open hash.";
    binmode(HASH);
    open HASHWORDS, ">hashwords" or die "Could not open hashwords.";
    binmode(HASHWORDS);

    $zzz = pack("N", 0);
    print HASHWORDS $zzz;
    for ($i=0; $i<$HASHSIZE; $i++){
    	
        if ($hash_array[$i] eq "") {print HASH $zzz};
        if ($hash_array[$i] ne "") {
            @dum = split (/::/,$hash_array[$i]);
            $pos = pack("N", tell(HASHWORDS));
            print HASH $pos;
            $wnum = pack("N", scalar(@dum));
            print HASHWORDS $wnum;
            foreach (@dum) { print HASHWORDS $wordpos{$_} };
        };   # if
    
    }; # for $i

close(HASH);
close(HASHWORDS);

};     # sub build_hash